#ifndef _RZB_DISPATCHER_H
#define _RZB_DISPATCHER_H

#include <uuid/uuid.h>
#include <pthread.h>
#include "rzb_global.h"

#ifdef RZB_PERF
// RZB_PERF TRACKER
typedef struct _PERF_TRACK
{
    unsigned routing_requests;
    unsigned no_routing_table;
    unsigned data_forwards;
    unsigned db_cache_checks;
    unsigned db_cache_miss;
    unsigned db_cache_hit_good;
    unsigned db_cache_hit_bad;
    unsigned web_tracker_insert;
    unsigned smtp_tracker_insert;
    unsigned dns_tracker_insert;
    unsigned db_conn;
    unsigned alerts;
    unsigned verdicts;
    unsigned long bytes_in;
    unsigned long bytes_out;
} PERF_TRACK;

extern PERF_TRACK perf;  // Global for tracking system statistics
extern pthread_mutex_t perfmutex;
#endif /*RZB_PERF*/

extern unsigned validNuggetCount; /* Number of valid nugget types */
extern uuid_t *validNuggetSet; /* List of valid UUIDs in full form */
extern unsigned dataTypesCount;
extern uuid_t *dataTypes;

void dispatchServer(const char *port);

HRESULT ResolveEventLookup(unsigned tempid, unsigned *realid);

#endif
