#ifndef RZB_ROUTER_H
#define RZB_ROUTER_H

#include <stdio.h>
#include <uuid/uuid.h>
#include <netinet/in.h>
#include <stdlib.h>
#include "rzb_global.h"
#include "rzb_nug_manage.h"

/* Routing Structures */
typedef struct _ROUTEENTRY
{
    NUGGETENTRY *nugget;
    struct _ROUTEENTRY *next;
} ROUTEENTRY;

typedef struct _APPENTRY
{
    uuid_t nugapp;
    ROUTEENTRY *ondeck;
    ROUTEENTRY *routehead;
    struct _APPENTRY *next;
} APPENTRY;

typedef struct _DATAENTRY
{
    uuid_t datatype;
    APPENTRY *apphead;
    struct _DATAENTRY *next;
} DATAENTRY;

/* Routing related function declarations */
HRESULT buildDefenseRouteTable(NUGGETENTRY **entry);
HRESULT printRoutingTable(void);
HRESULT addDefenseRouteEntry(NUGGETENTRY *entry);
HRESULT findDataEntry(DATAENTRY **found, NUGGETENTRY *entry);
HRESULT removeRouteByNugID(unsigned nugid);
DATAENTRY *getRoutingTableLoc(void);

#endif /* RZB_ROUTER_H */

