#include <getopt.h>

#include "config.h"
#include "rzb_global.h"
#include "rzb_conf.h"
#include "rzb_intel_global.h"
#include "rzb_intel_api.h"
#include "rzb_network.h"
#include "rzb_client.h"
#include "rzb_api.h"

static char SRC_IP[] = "192.168.1.6";
static char DST_IP[] = "204.11.59.2";
#define TX_ID 4000
#define FLAGS 1
static char QUERIES[] = "www.fark.com";
static char ANSWERS[] = "192.168.1.1";
static char AUTH_NS[] = "199.22.1.4";
static char ADD_REC[] = "NONE";

int main(int argc, char ** argv)
{
    DNS_TRACK_DATA data =
    {
        .src_ip = SRC_IP,
        .dst_ip = DST_IP,
        .tx_id = TX_ID,
        .flags = FLAGS,
        .queries = QUERIES,
        .answers = ANSWERS,
        .auth_ns = AUTH_NS,
        .add_rec = ADD_REC,
    };

    static const struct option long_options[] =
    {
        {"conf",required_argument, NULL, 'c'},
        {NULL, 0, NULL, 0}
    };

    int optId; /* holds the option index for getopt*/
    const char *configFile = "rzb.conf";
    int option_index = 0;

    while (1)
    {
        optId = getopt_long(argc, argv, "c:", long_options, &option_index);

        if (optId == -1)
            break;

        switch (optId)
        {
            case 'c':
                configFile = optarg;
                break;
            case '?':  /* getopt errors */
                break;
            default:
                break;
        }
    }

    readConfig(&nrtconfig, configFile);

    printf("<===DNS TRACKER TEST===>");
    sendDNSTrack(&data);
    printf("<===DNS DATA SENT--->");

    return 0;
}
